'FFSubmenu=Skalieren
'FFName=Scalieren&Kill Exif BigPreview
' Entstanden aus FF-Scalefix
' 14.6.2003 - 16.6.2003

' Alle im Vorschaufenster selektierten Bilder werden unter 
' Beibehaltung des Seitenverhltnisses auf die eingegebene Gre 
' skaliert (lngere Seite des Bildes).
' Speichert als JPG mit Qualitt 1%(schlecht) - 100%(beste)
'   (mit 0 %: Fixfoto-Einstellung)
' Hngt an Dateinamen '_Normgr'(e) an
' Speichert im gleichen Verzeichnis der Quelldatei
' Wenn 'Kill-EXIF' angehakt ist, werden Exif-Daten bei Abspeicherung
'   gelscht
' Schrittweises Skalieren ist nicht abgeschaltet (Bei starkem Vergrern 
'   kann der Arbeitsspeicher berlaufen --> Fixfoto strzt ab!)
' Anpassungen an FF-2.78Beta16  Heinz Hfling 21.1.2005
' Autokonfig hinzugefuegt Heinz Hfling 21.1.2005

option explicit
dim res,dlg,ctl_w,ctl_h,ctl_c
dim ctl_wt,ctl_ht,ctl_ct,ctl_p,ctl_pi
 dim ctl_explain1, ctl_explain2, ctl_explain3, ctl_explain4 
 dim ctl_explain5, ctl_explain6, ctl_explain7
dim i,imagecount,width,height,wstep,hstep, jpgqual
dim fso,path,dir,file,ext,pvpath
 dim ctl_j, ctl_jt, ctl_ke, ctl_ket, EX_kill, ctl_ok
 dim exiftag
   
   
set fso = CreateObject("Scripting.FileSystemObject")

dlg = "Skalieren auf Normgre + wahlweise Kill-EXIF + JPG-Qualitt"
ctl_explain1 = "Dieses Skript skaliert alle markierten Bilder verhltnistreu"
ctl_explain2 = "auf die einzugebende Pixelzahl der lngeren Seite"
ctl_explain3 = "- Verkleinert mit Zwischenschritten und Schrfen"
ctl_explain4 = "- Speichert als JPG mit Qualitt 1%(schlecht) - 100%(beste)    (mit 0 %: Fixfoto-Einstellung)"
'ctl_explain5 = 

ctl_explain6 = "- Hngt an Dateinamen '_Normgr' (e) an"
ctl_explain7 = "FIXFOTO-Support-Team //  June 2003"

   ctl_w  = "width"
   ctl_wt = "Pixelzahl lngere Bildseite"
   ctl_j  = "height"
   ctl_ke = FALSE
   ctl_ket= "Kill-Exif ?"
   ctl_jt = "% JPG-Qualitt"
   ctl_p  = "Vorschaubild"
   ctl_pi = "preview"
   ctl_ok = "Ausfhren"
   exiftag= FALSE
   EX_kill= FALSE
wstep=1
hstep=2


imagecount = FF_GetImageCount

'Definition des Dialogfensters:
call FF_AddDialog(dlg,232, 266)     ' old: 144,228)

call FF_AddControl(dlg,ctl_explain1,"STATIC",2,  2,140,6)
call FF_AddControl(dlg,ctl_explain2,"STATIC",2, 8,130,8)
call FF_AddControl(dlg,ctl_explain3,"STATIC",2, 18,130,7)
call FF_AddControl(dlg,ctl_explain4,"STATIC",2, 24,240,7)
'call FF_AddControl(dlg,ctl_explain5,"STATIC",14,34,230,7)
call FF_AddControl(dlg,ctl_explain6,"STATIC",2, 30,130,7)
call FF_AddControl(dlg,ctl_explain7,"STATIC",11,260,120,7)

call FF_AddControl(dlg,ctl_w,"EDIT",2,40,20,8)
call FF_AddControl(dlg,ctl_wt,"STATIC",24,40,66,8)

call FF_AddControl(dlg, ctl_ke, "BOOL",  94,40,6,8)
call FF_AddControl(dlg, ctl_ket,"STATIC",101,40,30,8)
call FF_AddControl(dlg,ctl_j,"EDIT",128,40,14,8)
call FF_AddControl(dlg,ctl_jt,"STATIC",144,40,36,8)

call FF_AddControl(dlg,ctl_p,"BUTTON",186,38,40,10)
call FF_AddControl(dlg,ctl_pi,"IMAGE",11,50,206,206)
call FF_AddControl(dlg,ctl_ok,"BUTTON",186,256,40,10)

call FF_SetControl(dlg,ctl_ke,  FALSE)
call FF_SetControl(dlg,ctl_w,   "1800") ' vorgeschlagene Pixelzahl
call FF_SetControl(dlg,ctl_j,   "100")  ' vorgeschlagene JPG-Qualitaet



do   'Dialog-Schleife, Eingabewerte knnen mehrmals angepasst werden
 call FF_ActivateControl(dlg,ctl_w)
 res = FF_ShowDialog(dlg)
 width   = FF_GetControl(dlg,ctl_w)
 height  = width

 EX_kill = FF_GetControl(dlg,ctl_ke)

 jpgqual = FF_GetControl(dlg,ctl_j) 
 if jpgqual < 0 then jpgqual = 0
 if jpgqual > 100 then jpgqual = 100
 
 'path = FF_GetControl(dlg,ctl_c)

 select case res
  case ctl_ok
   if width > 0 then
    if height > 0 then
      FF_CloseDialog dlg
      call Process()
      exit do
    end if
   end if
  case ctl_p
   if width > 0 then
    if height > 0 then
     call Preview()
    end if
   end if
  case "CANCEL"
   FF_CloseDialog dlg
   exit do
 end select
loop
if pvpath <> "" then
 call fso.DeleteFile(pvpath)
end if



' Skalierung aller Bilder durchfuehren
sub Process
 for i=0 to imagecount-1
  path = FF_GetImageName(i)
  call FF_LoadImage(path)
    exiftag = FF_HasExif()

  call StepScale(width,height) ' Verkleinern in 50% Schritten

'  call FF_HQScale (width,height,TRUE)
  call FF_Sharp(32,true,true,true)

  call SplitPath(path,dir,file,ext)

  if ( exiftag AND (EX_kill = 1) ) then
    call FF_KillExif()
  end if

 call FF_SaveImage(dir & file & "_Normgr" & ext, jpgqual)
' Wer 'Normgr_' voranstellen will, kommentiere die vorige Zeile aus und
' aktiviere die folgende 
'call FF_SaveImage(dir & "Normgr_" & file &  ext, jpgqual)

  call FF_SetProgress(i+1,imagecount)
 next
end sub



sub Preview         'Berechnung des Vorschaubildes
 path = FF_GetImageName(0)
 call FF_LoadImage(path)

 call StepScale(width,height)

 call SplitPath(path,dir,file,ext)
 pvpath = dir & "FFScript_Temp.jpg"
 call FF_SaveImage(pvpath,0)
 call FF_SetControl(dlg,ctl_pi,pvpath)

end sub


' liefert Verzeichnis mit abschliessendem Backslash,
' Dateinamen und Erweiterung mit einleitendem Punkt
sub SplitPath(path, byref dir, byref file, byref ext)
 dir = fso.GetParentFolderName(path) & "\"
 file = fso.GetBaseName(path)
 ext = "." & fso.GetExtensionName(path)
end sub


' Schrittweise verkleinern mit Zwischenschaerfen
sub StepScale(width,height)
 do
  wstep = FF_GetImageWidth()
  hstep = FF_GetImageHeight()

  if(wstep < width  * 2) then exit do  ' Wenn akt. Bildgroesse unter 
  if(hstep < height * 2) then exit do  ' die doppelte Zielgroesse fllt, 
  call FF_Sharp(32,true,true,true)                    ' aufhoeren zu verkleinern

  call FF_HQScale(wstep/2,hstep/2,true) ' Halbieren der Groee
 loop
 
 call FF_HQScale(width,height,true)
end sub 
